# This file was auto-generated by Fern from our API Definition.

from ....core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import datetime as dt
from .job_interview_stage_job import JobInterviewStageJob
from .remote_data import RemoteData
from ....core.pydantic_utilities import IS_PYDANTIC_V2


class JobInterviewStage(UniversalBaseModel):
    """
    # The JobInterviewStage Object

    ### Description

    The `JobInterviewStage` object is used to represent a particular recruiting stage for an `Application`. A given `Application` typically has the `JobInterviewStage` object represented in the current_stage field.

    ### Usage Example

    Fetch from the `LIST JobInterviewStages` endpoint and view the job interview stages used by a company.
    """

    id: typing.Optional[str]
    remote_id: typing.Optional[str] = pydantic.Field()
    """
    The third-party API ID of the matching object.
    """

    created_at: typing.Optional[dt.datetime] = pydantic.Field()
    """
    The datetime that this object was created by Merge.
    """

    modified_at: typing.Optional[dt.datetime] = pydantic.Field()
    """
    The datetime that this object was modified by Merge.
    """

    name: typing.Optional[str] = pydantic.Field()
    """
    Standard stage names are offered by ATS systems but can be modified by users.
    """

    job: typing.Optional[JobInterviewStageJob] = pydantic.Field()
    """
    This field is populated only if the stage is specific to a particular job. If the stage is generic, this field will not be populated.
    """

    stage_order: typing.Optional[int] = pydantic.Field()
    """
    The stage’s order, with the lowest values ordered first. If the third-party does not return details on the order of stages, this field will not be populated.
    """

    remote_was_deleted: typing.Optional[bool] = pydantic.Field()
    """
    Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/).
    """

    field_mappings: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]]
    remote_data: typing.Optional[typing.List[RemoteData]]

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
